from flask import Flask,request,session
from flask.templating import render_template
from flask_sqlalchemy import SQLAlchemy
from flask_migrate import Migrate,MigrateCommand
from flask_script import Manager
from flask_restful import Api,Resource



HOST = '127.0.0.1'
PORT = '3306'
USER = 'root'
PWD = 'root'
DATABASE = 'lianxi'

DB_URI = f'mysql+pymysql://{USER}:{PWD}@{HOST}:{PORT}/{DATABASE}?charset=utf8'
app = Flask(__name__)
app.config['SQLALCHEMY_DATABASE_URI'] = DB_URI
db = SQLAlchemy(app)
manager = Manager(app)
Migrate(app,db)
api = Api(app)


class Test01(db.Model):
    __tablename__ = 'test01'
    uname = db.Column(db.String(12),nullable = False)
    pwd = db.Column(db.String(12),nullable = False)
    id = db.Column(db.Integer,primary_key = True,autoincrement = True)

manager.add_command('db',MigrateCommand)

普通的视图
@app.route('/login/',methods = ['GET','POST'])
def login():
    if request.method == 'GET':
        return render_template('login.html')
    else:
        uname = request.form.get('uname')
        pwd = request.form.get('pwd')
        try:
            if all([uname,pwd]):
                if len(uname)>3 and len(pwd)>3:
                    #增
                    # t = Test01(uname = uname,pwd = pwd)
                    # db.session.add(t)
                    # db.session.commit()
                    #改
                    re = db.session.query(Test01).filter(Test01.uname == 'LIZHE')
                    re.uname = uname
                    db.session.commit()
                    return render_template('ok.html')
        except Exception as e:
            print(e)
            return '用户名或密码不符合规则'            
  

# # resful写接口    
class Login(Resource):
    def get(self):
        # title = session.get('title')
        # if title == 'ok':
        #     return render_template('ok.html')  
        # else:
            return render_template('login.html')
    def post(self):
        try:
            uname = request.form.get('uname') 
            pwd = request.form.get('pwd') 
            if all([uname,pwd]):
                # 增
                t1 = Test01(uname = uname,pwd = pwd)    
                db.session.add(t1)
                db.session.commit()
                session['title'] = 'ok'
                return render_template('ok.html')
        except Exception as e:
            print(e)
            return {
                'tips':'用户名或密码不能为空'
            }       
api.add_resource(Login,'/login/',endpoint = 'log')   # url_for(‘log’)得到的是 login/路径         



if __name__ == '__main__':  
    # manager.run()
    app.run(debug=True)



        
